package org.gazelle.proxy.loadtests;

import java.io.File;
import java.util.Random;
import java.util.concurrent.Callable;

import org.dcm4che2.tool.dcmsnd.DcmSnd;

public class DicomSendMessageTask implements Callable<String> {

	private String host;
	private int port;
	private String aeName;
	private File dicomFolder;
	private Random r = new Random();

	public DicomSendMessageTask(String host, int port, String aeName, String dicomFolder) {
		super();
		this.host = host;
		this.port = port;
		this.aeName = aeName;
		this.dicomFolder = new File(dicomFolder);
	}

	@Override
	public String call() throws Exception {
		try {
			String randomFile = getRandomFile(dicomFolder);
			String[] args = { aeName + "@" + host + ":" + port, randomFile };
			DcmSnd.main(args);
			return randomFile;
		} catch (Throwable e) {
			return "Failed " + e.getMessage();
		}
	}

	private String getRandomFile(File file) {
		if (file.isFile()) {
			return file.getAbsolutePath();
		} else {
			File[] listFiles = file.listFiles();
			int i = r.nextInt(listFiles.length);
			File rFile = listFiles[i];
			if (rFile.getName().startsWith(".")) {
				return getRandomFile(dicomFolder);
			} else {
				return getRandomFile(rFile);
			}
		}
	}

}
