package org.gazelle.proxy.loadtests;

import java.io.OutputStream;

import ca.uhn.hl7v2.llp.MinLLPWriter;

public class HL7SendMessageTask extends SendMessageOnSocketCallable {

	private static final String LINE_FEED = "\r\n";
	private static final String DEFAULT_QUERY = "MSH|^~\\&|TLS_TOOL|IL_LAB_BRK|MODULAB_LIP|MODULAB|20110414121938||QBP^SLI^QBP_Q11|627498221219696500|D|2.5|||||ITA||EN"
			+ LINE_FEED
			+ "QPD|SLI^Specimen Labeling Instructions^IHE_LABTF|QRY68751825846181340|||PG2^OP^OID^ISO||||"
			+ LINE_FEED + "RCP|I||R";

	public HL7SendMessageTask(String host, int port) {
		super(host, port);
	}

	@Override
	public String writeInSocket(OutputStream outputStream) throws Exception {
		MinLLPWriter mllpWriter = new MinLLPWriter(outputStream);
		mllpWriter.writeMessage(DEFAULT_QUERY);
		return "OK";
	}

}
