package org.gazelle.proxy.loadtests;

import java.io.OutputStream;
import java.io.OutputStreamWriter;

public class HTTPSendMessageTask extends SendMessageOnSocketCallable {

	private static final String LINE_FEED = "\r\n";
	private static final String DEFAULT_QUERY = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" "
			+ "xmlns:ws=\"http://ws.svs.simulators.gazelle.ihe.net/\">"
			+ LINE_FEED
			+ "   <soapenv:Header/>"
			+ LINE_FEED
			+ "   <soapenv:Body><ws:sendMessage></ws:sendMessage>"
			+ LINE_FEED
			+ "   </soapenv:Body>"
			+ LINE_FEED + "</soapenv:Envelope>";

	public HTTPSendMessageTask(String host, int port) {
		super(host, port);
	}

	@Override
	public String writeInSocket(OutputStream outputStream) throws Exception {
		// /SVSSimulator-SVSSimulator-ejb-1.0/SimulatorWS
		// http://192.168.20.50:8080/SVSSimulator-SVSSimulator-ejb-1.0/SimulatorWS?wsdl

		OutputStreamWriter writer = new OutputStreamWriter(outputStream, "UTF-8");
		byte[] bytes = DEFAULT_QUERY.getBytes("UTF-8");
		println(writer, "POST /SVSSimulator-SVSSimulator-ejb-1.0/SimulatorWS HTTP/1.1");
		println(writer, "User-Agent: TLS IHE testing tools");
		println(writer, "Content-Type: application/soap+xml; charset=utf-8");
		println(writer, "Accept: */*");
		println(writer, "Host: " + host + ":" + port);
		println(writer, "Connection: close");
		println(writer, "Content-Length: " + bytes.length);
		println(writer, "");
		writer.flush();
		outputStream.write(bytes);

		return "OK";
	}

}
