package org.gazelle.proxy.loadtests;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Writer;
import java.net.Socket;
import java.util.concurrent.Callable;

public abstract class SendMessageOnSocketCallable implements Callable<String> {

	protected String host;
	protected int port;

	public SendMessageOnSocketCallable(String host, int port) {
		super();
		this.host = host;
		this.port = port;
	}

	@Override
	public String call() throws Exception {
		try {

			final Socket socket = new Socket(host, port);
			final InputStream inputStream = socket.getInputStream();
			final OutputStream outputStream = socket.getOutputStream();
			String result = writeInSocket(outputStream);
			outputStream.flush();

			Thread socketClose = new Thread() {
				@Override
				public void run() {
					try {
						sleep(1000);
						if (!socket.isClosed()) {
							outputStream.close();
							inputStream.close();
							socket.close();
						}
					} catch (Exception e) {
						// socket closed
					}
				}
			};
			socketClose.start();

			while (!socket.isClosed()) {
				if (inputStream.read() == -1) {
					break;
				}
			}

			return result;
		} catch (Throwable e) {
			return "Failed " + e.getMessage();
		}
	}

	public abstract String writeInSocket(OutputStream outputStream) throws Exception;

	protected void println(Writer os, String string) throws IOException {
		os.write(string);
		os.write("\r\n");
	}
}
