package org.gazelle.proxy.loadtests;

import java.io.OutputStream;
import java.util.Date;
import java.util.Random;

import org.apache.commons.lang.RandomStringUtils;
import org.openhealthtools.openatna.syslog.message.StringLogMessage;
import org.openhealthtools.openatna.syslog.protocol.ProtocolMessage;
import org.openhealthtools.openatna.syslog.protocol.ProtocolMessageFactory;

public class SyslogSendMessageTask extends SendMessageOnSocketCallable {

	private Random r = new Random();

	public SyslogSendMessageTask(String host, int port) {
		super(host, port);
	}

	@Override
	public String writeInSocket(OutputStream outputStream) throws Exception {

		ProtocolMessage<String> sl = new ProtocolMessage<String>(10, 5, ProtocolMessageFactory.formatDate(new Date()),
				randomString(), new StringLogMessage("<atna>" + randomString() + "</atna>"), randomString(),
				randomString(), "1234");
		byte[] bytes = sl.toByteArray();
		outputStream.write(Integer.toString(bytes.length).getBytes());
		outputStream.write(" ".getBytes());
		outputStream.write(bytes);
		return "OK";
	}

	private String randomString() {
		return RandomStringUtils.randomAlphabetic(5 + r.nextInt(5));
	}
}
